'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.run = undefined;

var _execa = require('execa');

var _execa2 = _interopRequireDefault(_execa);

var _utils = require('./utils');

var _options = require('./options');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createJqCommand = function createJqCommand(filter, json) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var command = {
    cmd: 'jq',
    params: []
  };

  if (options.nullInput === true) {
    command.params = (0, _options.buildNullInputParams)(filter, json);
  } else {
    (0, _utils.validateJsonPath)(json);
    command.params = [filter, json];
  }

  return command;
};

var run = exports.run = function run(filter, json) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  return new Promise(function (resolve, reject) {
    var _createJqCommand = createJqCommand(filter, json, options);

    var cmd = _createJqCommand.cmd;
    var params = _createJqCommand.params;

    (0, _execa2.default)(cmd, params).then(function (_ref) {
      var stdout = _ref.stdout;

      resolve(JSON.parse(stdout));
    }).catch(reject);
  });
};